Index: trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingChartView.cs
===================================================================
--- trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingChartView.cs	(revision 14412)
+++ trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingChartView.cs	(revision 14418)
@@ -61,4 +61,13 @@
         InitData();
         GenerateChart();
+
+        foreach (var row in dataRows) {
+          string variableName = row.Name;
+          if (!IsVariableChecked(variableName)) {
+            dataTableView.SetRowEnabled(variableName, false);
+            dataTable.SelectedRows.Remove(variableName);
+            dataTablePerVariable.Remove(dataTablePerVariable.Find(x => (x.Name == variableName)));
+          }
+        }
       }
     }
@@ -71,17 +80,14 @@
 
       //add data rows to data tables according to checked item list
-      foreach (var checkedItem in Content.VariableItemList.CheckedItems) {
-        string variableName = Content.VariableItemList[checkedItem.Index].Value;
+      foreach (var row in dataRows) {
+        string variableName = row.Name;
+
+        //add row to data table
+        dataTable.Rows.Add(row);
+
+        //add row to data table per variable
         PreprocessingDataTable d = new PreprocessingDataTable(variableName);
-        DataRow row = GetDataRow(variableName);
-
-        if (row != null) {
-          //add row to data table
-          dataTable.Rows.Add(row);
-
-          //add row to data table per variable
-          d.Rows.Add(row);
-          dataTablePerVariable.Add(d);
-        }
+        d.Rows.Add(row);
+        dataTablePerVariable.Add(d);
       }
 
@@ -95,10 +101,12 @@
         string variableName = item.Value.Value;
 
-        // not checked -> remove
+
         if (!IsVariableChecked(variableName)) {
+          // not checked -> remove
           dataTableView.SetRowEnabled(variableName, false);
           dataTable.SelectedRows.Remove(variableName);
           dataTablePerVariable.Remove(dataTablePerVariable.Find(x => (x.Name == variableName)));
         } else {
+          // checked -> add
           DataRow row = GetDataRow(variableName);
           DataRow selectedRow = GetSelectedDataRow(variableName);
Index: trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingCheckedVariablesView.cs
===================================================================
--- trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingCheckedVariablesView.cs	(revision 14412)
+++ trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingCheckedVariablesView.cs	(revision 14418)
@@ -56,8 +56,11 @@
 
       if (Content.VariableItemList == null) {
-        Content.VariableItemList = Content.CreateVariableItemList();
+        IList<string> inputs = Content.PreprocessingData.InputVariables;
+        if (Content.PreprocessingData.TargetVariable != null)
+          inputs = inputs.Union(new[] {Content.PreprocessingData.TargetVariable}).ToList();
+        Content.VariableItemList = Content.CreateVariableItemList(inputs);
       } else {
         var checkedNames = Content.VariableItemList.CheckedItems.Select(x => x.Value.Value);
-        Content.VariableItemList = Content.CreateVariableItemList(checkedNames);
+        Content.VariableItemList = Content.CreateVariableItemList(checkedNames.ToList());
       }
       Content.VariableItemList.CheckedItemsChanged += CheckedItemsChanged;
Index: trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/PreprocessingChartContent.cs
===================================================================
--- trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/PreprocessingChartContent.cs	(revision 14412)
+++ trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/PreprocessingChartContent.cs	(revision 14418)
@@ -23,5 +23,4 @@
 using System.Collections.Generic;
 using System.Drawing;
-using System.Linq;
 using HeuristicLab.Analysis;
 using HeuristicLab.Common;
@@ -126,9 +125,10 @@
 
 
-    public ICheckedItemList<StringValue> CreateVariableItemList(IEnumerable<string> checkedItems = null) {
+    public ICheckedItemList<StringValue> CreateVariableItemList(IList<string> checkedItems = null) {
+      if (checkedItems == null) checkedItems = new string[0];
       ICheckedItemList<StringValue> itemList = new CheckedItemList<StringValue>();
       foreach (string name in PreprocessingData.GetDoubleVariableNames()) {
         var n = new StringValue(name);
-        itemList.Add(n, (checkedItems == null) ? true : checkedItems.Contains(name));
+        itemList.Add(n, checkedItems.Contains(name));
       }
       return new ReadOnlyCheckedItemList<StringValue>(itemList);